%define anolis_release 1

Summary:  iSCSI daemon and utility programs
Name:     iscsi-initiator-utils
Version:  2.1.8
Release:  %{anolis_release}%{?dist}
License:  GPLv2+
URL:      https://github.com/open-iscsi/open-iscsi
Source0:  https://github.com/open-iscsi/open-iscsi/archive/refs/tags/%{version}.tar.gz
Source1:  04-iscsi
Source2:  iscsi-tmpfiles.conf

	
Patch0001: 0001-unit-file-tweaks.patch
Patch0002: 0002-idmb_rec_write-check-for-tpgt-first.patch
Patch0003: 0003-idbm_rec_write-seperate-old-and-new-style-writes.patch
Patch0004: 0004-idbw_rec_write-pick-tpgt-from-existing-record.patch
Patch0005: 0005-update-initscripts-and-docs.patch
Patch0006: 0006-use-var-for-config.patch
Patch0007: 0007-libiscsi.patch
Patch0008: 0008-libiscsi-introduce-sessions-API.patch
Patch0009: 0009-remove-the-offload-boot-supported-ifdef.patch
Patch0010: 0010-Revert-iscsiadm-return-error-when-login-fails.patch
Patch0011: 0011-use-var-lib-iscsi-in-libopeniscsiusr.patch
Patch0012: 0012-Coverity-scan-fixes.patch
Patch0013: 0013-iscsi_if.h-replace-zero-length-array-with-flexible-a.patch
Patch0014: 0014-minor-service-file-updates.patch
Patch0015: 0015-try-not-to-require-network-online.patch
Patch0016: 0016-add-some-service-in-system.patch
#Patch0017: 0017-add-ISCSI_VERSION_STR-define.patch

Patch1001: 1001-add-ISCSI_VERSION_STR-define.patch
Patch1002: 1002-fix-the-libiscsi-build-error.patch
Patch1003: 1003-change-the-sbin-dir-to-usr-sbin.patch

BuildRequires: flex bison doxygen kmod-devel systemd-units
BuildRequires: autoconf automake libtool libmount-devel openssl-devel
BuildRequires: isns-utils-devel
BuildRequires: systemd-devel
Requires: %{name}-iscsiuio >= %{version}-%{release}

# Old NetworkManager expects the dispatcher scripts in a different place
Conflicts: NetworkManager < 1.20

%global _hardened_build 1
%global __provides_exclude_from ^(%{python3_sitearch}/.*\\.so)$

%description
The iscsi package provides the server daemon for the iSCSI protocol,
as well as the utility programs used to manage it. iSCSI is a protocol
for distributed disk access using SCSI commands sent over Internet
Protocol networks.

%package iscsiuio
Summary: Userspace configuration daemon required for some iSCSI hardware
License: BSD
Requires: %{name} = %{version}-%{release}

%description iscsiuio
The iscsiuio configuration daemon provides network configuration help
for some iSCSI offload hardware.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package -n python3-%{name}
Summary: Python %{python3_version} bindings to %{name}
Requires: %{name} = %{version}-%{release}
BuildRequires: python3-devel
BuildRequires: python3-setuptools
#BuildRequires: make

%description -n python3-%{name}
The %{name}-python3 package contains Python %{python3_version} bindings to the
libiscsi interface for interacting with %{name}

%prep
%autosetup -p1 -n open-iscsi-%{version}

# change exec_prefix, there's no easy way to override
%{__sed} -i -e 's|^exec_prefix = /$|exec_prefix = %{_exec_prefix}|' Makefile

%build
# avoid undefined references linking failures
%undefine _ld_as_needed

# configure sub-packages from here
# letting the top level Makefile do it will lose setting from rpm
cd iscsiuio
autoreconf --install
%{configure}
cd ..

%{__make} OPTFLAGS="%{optflags} %{?__global_ldflags}"

pushd libiscsi
%py3_build
touch -r libiscsi.doxy html/*
popd

%install
%{__make} DESTDIR=%{?buildroot} LIB_DIR=%{_libdir} \
          install_programs \
          install_doc \
          install_etc \
          install_libopeniscsiusr
# upstream makefile doesn't get everything the way we like it
# rm $RPM_BUILD_ROOT%%{_sbindir}/iscsi_discovery
rm $RPM_BUILD_ROOT%{_mandir}/man8/iscsi_discovery.8
rm $RPM_BUILD_ROOT%{_mandir}/man8/iscsi_fw_login.8
%{__install} -pm 755 usr/iscsistart $RPM_BUILD_ROOT%{_sbindir}
%{__install} -pm 755 iscsiuio/src/unix/iscsiuio $RPM_BUILD_ROOT%{_sbindir}
%{__install} -pm 644 doc/iscsistart.8 $RPM_BUILD_ROOT%{_mandir}/man8
%{__install} -pm 644 doc/iscsi-iname.8 $RPM_BUILD_ROOT%{_mandir}/man8
%{__install} -pm 644 iscsiuio/docs/iscsiuio.8 $RPM_BUILD_ROOT%{_mandir}/man8
%{__install} -d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
%{__install} -pm 644 iscsiuio/iscsiuiolog $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d

%{__install} -d $RPM_BUILD_ROOT%{_sharedstatedir}/iscsi
%{__install} -d $RPM_BUILD_ROOT%{_sharedstatedir}/iscsi/nodes
%{__install} -d $RPM_BUILD_ROOT%{_sharedstatedir}/iscsi/send_targets
%{__install} -d $RPM_BUILD_ROOT%{_sharedstatedir}/iscsi/static
%{__install} -d $RPM_BUILD_ROOT%{_sharedstatedir}/iscsi/isns
%{__install} -d $RPM_BUILD_ROOT%{_sharedstatedir}/iscsi/slp
%{__install} -d $RPM_BUILD_ROOT%{_sharedstatedir}/iscsi/ifaces

# for %%ghost
%{__install} -d $RPM_BUILD_ROOT%{_rundir}/lock/iscsi
touch $RPM_BUILD_ROOT%{_rundir}/lock/iscsi/lock


%{__install} -d $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsi.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsi-starter.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsi-init.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsi-onboot.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsi-shutdown.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsid.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsid.socket $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsiuio.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsiuio.socket $RPM_BUILD_ROOT%{_unitdir}

%{__install} -d $RPM_BUILD_ROOT%{_libexecdir}
%{__install} -pm 755 etc/systemd/iscsi-mark-root-nodes $RPM_BUILD_ROOT%{_libexecdir}

%{__install} -d $RPM_BUILD_ROOT%{_prefix}/lib/NetworkManager/dispatcher.d
%{__install} -pm 755 %{SOURCE1} $RPM_BUILD_ROOT%{_prefix}/lib/NetworkManager/dispatcher.d

%{__install} -d $RPM_BUILD_ROOT%{_tmpfilesdir}
%{__install} -pm 644 %{SOURCE2} $RPM_BUILD_ROOT%{_tmpfilesdir}/iscsi.conf

%{__install} -d $RPM_BUILD_ROOT%{_libdir}
%{__install} -pm 755 libiscsi/libiscsi.so.0 $RPM_BUILD_ROOT%{_libdir}
%{__ln_s}    libiscsi.so.0 $RPM_BUILD_ROOT%{_libdir}/libiscsi.so
%{__install} -d $RPM_BUILD_ROOT%{_includedir}
%{__install} -pm 644 libiscsi/libiscsi.h $RPM_BUILD_ROOT%{_includedir}

mkdir -p $RPM_BUILD_ROOT/%{_udevrulesdir}
mv $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/50-iscsi-firmware-login.rules $RPM_BUILD_ROOT/%{_udevrulesdir}/50-iscsi-firmware-login.rules
rm -rf $RPM_BUILD_ROOT/%{_sysconfdir}/udev

%{__install} -d $RPM_BUILD_ROOT%{python3_sitearch}
pushd libiscsi
%py3_install
popd

%generate_compatibility_deps

%post
%systemd_post iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%preun
%systemd_preun iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%postun
%systemd_postun iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%post iscsiuio
%systemd_post iscsiuio.service iscsiuio.socket

%preun iscsiuio
%systemd_preun iscsiuio.service iscsiuio.socket

%postun iscsiuio
%systemd_postun iscsiuio.service iscsiuio.socket

%triggerun -- iscsi-initiator-utils < 2.1.4
systemctl --no-reload preset iscsi.service iscsi-starter.service &>/dev/null || :

%files
%dir %{abidir}
%doc README
%dir %{_sharedstatedir}/iscsi
%dir %{_sharedstatedir}/iscsi/nodes
%dir %{_sharedstatedir}/iscsi/isns
%dir %{_sharedstatedir}/iscsi/static
%dir %{_sharedstatedir}/iscsi/slp
%dir %{_sharedstatedir}/iscsi/ifaces
%dir %{_sharedstatedir}/iscsi/send_targets
%ghost %attr(0700, root, root) %{_rundir}/lock/iscsi
%ghost %attr(0600, root, root) %{_rundir}/lock/iscsi/lock
%{_unitdir}/iscsi.service
%{_unitdir}/iscsi-starter.service
%{_unitdir}/iscsi-onboot.service
%{_unitdir}/iscsi-init.service
%{_unitdir}/iscsi-shutdown.service
%{_unitdir}/iscsid.service
%{_unitdir}/iscsid.socket
%{_libexecdir}/iscsi-mark-root-nodes
%{_prefix}/lib/NetworkManager
%{_tmpfilesdir}/iscsi.conf
%dir %{_sysconfdir}/iscsi
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/iscsi/iscsid.conf
%{_sbindir}/iscsi-iname
%{_sbindir}/iscsiadm
%{_sbindir}/iscsid
%{_sbindir}/iscsistart
%{_sbindir}/iscsi-gen-initiatorname
%{_sbindir}/iscsi_discovery
%{_sbindir}/iscsi_fw_login
%{_sbindir}/iscsi_offload
%{abidir}/iscsi-iname-option.list
%{abidir}/iscsiadm-option.list
%{abidir}/iscsid-option.list
%{abidir}/iscsistart-option.list
%{abidir}/iscsi-gen-initiatorname-option.list
%{_libdir}/libiscsi.so.0
%{_mandir}/man8/iscsi-iname.8.*
%{_mandir}/man8/iscsiadm.8.*
%{_mandir}/man8/iscsid.8.*
%{_mandir}/man8/iscsistart.8.*
%{_mandir}/man8/iscsi-gen-initiatorname.8.*
%{_libdir}/libopeniscsiusr.so.*
%{abidir}/libopeniscsiusr.dump
%{abidir}/libiscsi.dump
%{_mandir}/man3/*
%{_udevrulesdir}/50-iscsi-firmware-login.rules

%files iscsiuio
%{_sbindir}/iscsiuio
%{abidir}/iscsiuio-option.list
%{_unitdir}/iscsiuio.service
%{_unitdir}/iscsiuio.socket
%config(noreplace) %{_sysconfdir}/logrotate.d/iscsiuiolog
%{_mandir}/man8/iscsiuio.8.*

%files devel
%doc libiscsi/html
%{_libdir}/libiscsi.so
%{_includedir}/libiscsi.h
%{_libdir}/libopeniscsiusr.so
%{_includedir}/libopeniscsiusr.h
%{_includedir}/libopeniscsiusr_common.h
%{_includedir}/libopeniscsiusr_iface.h
%{_includedir}/libopeniscsiusr_node.h
%{_includedir}/libopeniscsiusr_session.h
%{_libdir}/pkgconfig/libopeniscsiusr.pc

%files -n python3-%{name}
%{python3_sitearch}/*
%{abidir}/libiscsi.cpython-310-%{_arch}-linux-gnu.dump

%changelog
* Tue Mar 07 2023 happy_orange <songnannan@linux.alibaba.com> - 2.1.8-1
- update to 2.1.8

* Thu Dec 01 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.1.6-3
- fix iscsi-init.service start failed

* Thu Nov 03 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.1.6-2
- optimise spec file

* Wed Apr 20 2022 yuanhui <yuanhui@linux.alibaba.com> - 2.1.6-1
- Init iscsi-initiator-utils for anolis os 23
